/*
 * The contents of this file are subject to the Spread Non-Commercial 
 * License, Version 1.3 (the ``License''); you may not use
 * this file except in compliance with the License.  You may obtain a
 * copy of the License at:
 *
 * http://www.spread.org/license/
 *
 * or in the file ``license.txt'' found in this distribution.
 *
 * Software distributed under the License is distributed on
 * an AS IS basis, WITHOUT WARRANTY OF ANY KIND,
 * either express or implied. See the License for the
 * specific language governing rights and limitations
 * under the License.
 *
 * The Original Code is:
 *    The Spread Wide Area Group Communication Toolkit.
 *     
 * The Creators of the Original Code are:
 *    Yair Amir, Michal Miskin-Amir, Jonathan Stanton.
 *
 *    Portions created by the Initial Developers are
 *    Copyright (C) 1993-2000 Spread Concepts LLC <spread@spreadconcepts.com>
 *
 *    All Rights Reserved.
 *
 * Major Contributor(s):
 * ---------------
 *    Dan Schoenblum   dansch@cnds.jhu.edu - Java Interface Developer.
 *    John Schultz     jschultz@cnds.jhu.edu - contribution to process group membership.
 *    Theo Schlossnagle theos@cnds.jhu.edu - Perl library and Skiplists.
 *
 */


#ifndef INC_CONFIGURATION
#define INC_CONFIGURATION

#include "arch.h"
#include "spread_params.h"

typedef struct dummy_proc{
	char	name[MAX_PROC_NAME]; 
	int16	port;
	int16	seg_index;
	int16	index_in_seg;
	int32	id;
} proc;

typedef struct dummy_segment{
	int32 	bcast_address;
	int16	port;
	int	num_procs;
	int32	proc_ids[MAX_PROCS_SEGMENT];
} segment;

typedef struct dummy_configuration{
	int	num_segments;
	segment	segments[MAX_SEGMENTS];
} configuration;

int		Conf_init( char *file_name, char *my_name );
configuration	Conf(void);
proc		Conf_my(void);
int		Conf_proc_by_id( int32 id, proc *p );
int		Conf_proc_by_name( char *name, proc *p );
int		Conf_id_in_seg( segment *seg, int32 id );	
int		Conf_id_in_conf( configuration *config, int32 id );	
int		Conf_num_procs( configuration *config );
int32		Conf_leader( configuration *config );
int32		Conf_last( configuration *config );
int32		Conf_seg_leader( configuration *config, int16 seg_index );
int32		Conf_seg_last( configuration *config, int16 seg_index );
int	        Conf_num_procs_in_seg( configuration *config, int16 seg_index );
void		Conf_id_to_str( int32 id, char *str );
char 		Conf_print(configuration *config);

bool            Conf_get_dangerous_monitor_state(void);
void            Conf_set_dangerous_monitor_state(bool new_state);
int             Conf_get_link_protocol(void);
void            Conf_set_link_protocol(int protocol);

#endif /* INC_CONFIGURATION */
