/*
 * The contents of this file are subject to the Spread Non-Commercial 
 * License, Version 1.3 (the ``License''); you may not use
 * this file except in compliance with the License.  You may obtain a
 * copy of the License at:
 *
 * http://www.spread.org/license/
 *
 * or in the file ``license.txt'' found in this distribution.
 *
 * Software distributed under the License is distributed on
 * an AS IS basis, WITHOUT WARRANTY OF ANY KIND,
 * either express or implied. See the License for the
 * specific language governing rights and limitations
 * under the License.
 *
 * The Original Code is:
 *    The Spread Wide Area Group Communication Toolkit.
 *     
 * The Creators of the Original Code are:
 *    Yair Amir, Michal Miskin-Amir, Jonathan Stanton.
 *
 *    Portions created by the Initial Developers are
 *    Copyright (C) 1993-2000 Spread Concepts LLC <spread@spreadconcepts.com>
 *
 *    All Rights Reserved.
 *
 * Major Contributor(s):
 * ---------------
 *    Dan Schoenblum   dansch@cnds.jhu.edu - Java Interface Developer.
 *    John Schultz     jschultz@cnds.jhu.edu - contribution to process group membership.
 *    Theo Schlossnagle theos@cnds.jhu.edu - Perl library and Skiplists.
 *
 */


#ifndef	INC_GROUPS
#define	INC_GROUPS

#include "session.h"

#define		GOP	1
#define		GTRANS	2
#define		GGATHER	3
#define		GGT	4

void	G_init(void);

void	G_handle_reg_memb( configuration reg_memb, membership_id reg_memb_id );
void	G_handle_trans_memb( configuration trans_memb );
void	G_handle_join( char *private_group_name, char *group_name );
void	G_handle_leave( char *private_group_name, char *group_name );
void	G_handle_kill( char *private_group_name );
void	G_handle_groups( message_link *mess_link );

int	G_analize_groups( int num_groups, char target_groups[][MAX_GROUP_NAME], int target_sessions[] );
void    G_set_mask( int num_groups, char target_groups[][MAX_GROUP_NAME], int32u *grp_mask );

int	G_private_to_names( char *private_group_name, char *private_name, char *proc_name );
 
#endif	/* INC_GROUPS */
