/*
 * The contents of this file are subject to the Spread Non-Commercial 
 * License, Version 1.3 (the ``License''); you may not use
 * this file except in compliance with the License.  You may obtain a
 * copy of the License at:
 *
 * http://www.spread.org/license/
 *
 * or in the file ``license.txt'' found in this distribution.
 *
 * Software distributed under the License is distributed on
 * an AS IS basis, WITHOUT WARRANTY OF ANY KIND,
 * either express or implied. See the License for the
 * specific language governing rights and limitations
 * under the License.
 *
 * The Original Code is:
 *    The Spread Wide Area Group Communication Toolkit.
 *     
 * The Creators of the Original Code are:
 *    Yair Amir, Michal Miskin-Amir, Jonathan Stanton.
 *
 *    Portions created by the Initial Developers are
 *    Copyright (C) 1993-2000 Spread Concepts LLC <spread@spreadconcepts.com>
 *
 *    All Rights Reserved.
 *
 * Major Contributor(s):
 * ---------------
 *    Dan Schoenblum   dansch@cnds.jhu.edu - Java Interface Developer.
 *    John Schultz     jschultz@cnds.jhu.edu - contribution to process group membership.
 *    Theo Schlossnagle theos@cnds.jhu.edu - Perl library and Skiplists.
 *
 */


#ifndef INC_NETWORK
#define INC_NETWORK

#include "arch.h"
#include "scatter.h"
#include "configuration.h"

void	Net_init();
void	Net_set_membership( configuration memb );
int	Net_bcast( sys_scatter *scat );
int     Net_queue_bcast(sys_scatter *scat);
int     Net_flush_bcast(void);
int	Net_scast( int16 seg_index, sys_scatter *scat );
int	Net_ucast( int32 proc_id, sys_scatter *scat );
int	Net_recv ( sys_scatter *scat );
int	Net_send_token( sys_scatter *scat );
int	Net_recv_token( sys_scatter *scat );
int	Net_ucast_token( int32 proc_id, sys_scatter *scat );
channel Net_bcast_channel();
channel Net_token_channel();

#endif	/* INC_NETWORK */ 
