/*
 * The contents of this file are subject to the Spread Non-Commercial 
 * License, Version 1.3 (the ``License''); you may not use
 * this file except in compliance with the License.  You may obtain a
 * copy of the License at:
 *
 * http://www.spread.org/license/
 *
 * or in the file ``license.txt'' found in this distribution.
 *
 * Software distributed under the License is distributed on
 * an AS IS basis, WITHOUT WARRANTY OF ANY KIND,
 * either express or implied. See the License for the
 * specific language governing rights and limitations
 * under the License.
 *
 * The Original Code is:
 *    The Spread Wide Area Group Communication Toolkit.
 *     
 * The Creators of the Original Code are:
 *    Yair Amir, Michal Miskin-Amir, Jonathan Stanton.
 *
 *    Portions created by the Initial Developers are
 *    Copyright (C) 1993-2000 Spread Concepts LLC <spread@spreadconcepts.com>
 *
 *    All Rights Reserved.
 *
 * Major Contributor(s):
 * ---------------
 *    Dan Schoenblum   dansch@cnds.jhu.edu - Java Interface Developer.
 *    John Schultz     jschultz@cnds.jhu.edu - contribution to process group membership.
 *    Theo Schlossnagle theos@cnds.jhu.edu - Perl library and Skiplists.
 *
 */


#ifndef	INC_SESSION
#define	INC_SESSION

#include "arch.h"
#include "scatter.h"
#include "configuration.h"
#include "prot_objs.h"
#include "sess_types.h"

typedef	struct	dummy_message_link {
	message_obj			*mess;
	struct	dummy_message_link	*next;
} message_link;

struct partial_message_info {
        int     in_mess_head;
        int     cur_element;
        int     cur_byte;
        int     total_bytes;
};

typedef	struct	dummy_session {
	char		name[MAX_PRIVATE_NAME+1]; /* +1 for the null */
	int32		address;
	int		status; /* OP_SESSION or KILLED SESSION and with or without membership */
        int             priority;
	mailbox		mbox;
	int		type; /* inet or unix */ 
        int             down_queue;             /* Down queue to protocol */
        struct partial_message_info     read;   /* Read Msg from Client */
        message_obj     *read_mess;             /* Read Msg from Client */
	int		num_mess;               /* Write Queue to Client */
        struct partial_message_info     write;  /* Write Queue to Client */
	message_link	*first;                 /* Write Queue to Client */
	message_link	*last;                  /* Write Queue to Client */
} session;

void	Sess_init(void);
void	Sess_block_users_level(void);
void	Sess_unblock_users_level(void);
void    Sess_block_user(int xxx);
void    Sess_unblock_user(int xxx);
void	Sess_deliver_message( message_link *mess_link );
void	Sess_deliver_reg_memb( configuration reg_memb, membership_id reg_memb_id );
void	Sess_deliver_trans_memb( configuration trans_memb );
void    Flip_mess( message_header *head_ptr );
void    Sess_write_scat( int ses, message_link *mess_link, int *needed );
void    Sess_write(int ses, message_link *mess_link, int *needed );

#endif	/* INC_SESSION */
