/*
 * The contents of this file are subject to the Spread Non-Commercial 
 * License, Version 1.3 (the ``License''); you may not use
 * this file except in compliance with the License.  You may obtain a
 * copy of the License at:
 *
 * http://www.spread.org/license/
 *
 * or in the file ``license.txt'' found in this distribution.
 *
 * Software distributed under the License is distributed on
 * an AS IS basis, WITHOUT WARRANTY OF ANY KIND,
 * either express or implied. See the License for the
 * specific language governing rights and limitations
 * under the License.
 *
 * The Original Code is:
 *    The Spread Wide Area Group Communication Toolkit.
 *     
 * The Creators of the Original Code are:
 *    Yair Amir, Michal Miskin-Amir, Jonathan Stanton.
 *
 *    Portions created by the Initial Developers are
 *    Copyright (C) 1993-2000 Spread Concepts LLC <spread@spreadconcepts.com>
 *
 *    All Rights Reserved.
 *
 * Major Contributor(s):
 * ---------------
 *    Dan Schoenblum   dansch@cnds.jhu.edu - Java Interface Developer.
 *    John Schultz     jschultz@cnds.jhu.edu - contribution to process group membership.
 *    Theo Schlossnagle theos@cnds.jhu.edu - Perl library and Skiplists.
 *
 */


/*
  Don't include this file, include sp.h
*/ 

/* Interface routines */
int	SP_version( int *major_version, int *minor_version, int *patch_version);

int	SP_connect( const char *spread_name, const char *private_name,
		    int priority, int group_membership, mailbox *mbox,
		    char *private_group );

int	SP_connect_timeout( const char *spread_name, const char *private_name,
		    int priority, int group_membership, mailbox *mbox,
		    char *private_group, sp_time time_out );

int	SP_disconnect( mailbox mbox );

int	SP_join( mailbox mbox, const char *group );

int	SP_leave( mailbox mbox, const char *group );

int	SP_multicast( mailbox mbox, service service_type, 
		      const char *group,
		      int16 mess_type, int mess_len, const char *mess );

int	SP_scat_multicast( mailbox mbox, service service_type,
                           const char *group,
			   int16 mess_type, const scatter *scat_mess );

int	SP_multigroup_multicast( mailbox mbox, service service_type,
				 int num_groups,
				 const char groups[][MAX_GROUP_NAME],
				 int16 mess_type, int mess_len,
				 const char *mess );

int	SP_multigroup_scat_multicast( mailbox mbox, service service_type,
				      int num_groups,
				      const char groups[][MAX_GROUP_NAME],
				      int16 mess_type,
				      const scatter *scat_mess );

int	SP_receive( mailbox mbox, service *service_type,
		    char sender[MAX_GROUP_NAME], int max_groups,
		    int *num_groups, char groups[][MAX_GROUP_NAME],
		    int16 *mess_type, int *endian_mismatch,
		    int max_mess_len, char *mess );

int	SP_scat_receive( mailbox mbox, service *service_type,
			 char sender[MAX_GROUP_NAME], int max_groups,
			 int *num_groups, char groups[][MAX_GROUP_NAME],
			 int16 *mess_type, int *endian_mismatch,
			 scatter *scat_mess );

int	SP_poll( mailbox mbox );

int	SP_equal_group_ids( group_id g1, group_id g2 );

void	SP_error( int error );
