/*
 * The contents of this file are subject to the Spread Non-Commercial 
 * License, Version 1.3 (the ``License''); you may not use
 * this file except in compliance with the License.  You may obtain a
 * copy of the License at:
 *
 * http://www.spread.org/license/
 *
 * or in the file ``license.txt'' found in this distribution.
 *
 * Software distributed under the License is distributed on
 * an AS IS basis, WITHOUT WARRANTY OF ANY KIND,
 * either express or implied. See the License for the
 * specific language governing rights and limitations
 * under the License.
 *
 * The Original Code is:
 *    The Spread Wide Area Group Communication Toolkit.
 *     
 * The Creators of the Original Code are:
 *    Yair Amir, Michal Miskin-Amir, Jonathan Stanton.
 *
 *    Portions created by the Initial Developers are
 *    Copyright (C) 1993-2000 Spread Concepts LLC <spread@spreadconcepts.com>
 *
 *    All Rights Reserved.
 *
 * Major Contributor(s):
 * ---------------
 *    Dan Schoenblum   dansch@cnds.jhu.edu - Java Interface Developer.
 *    John Schultz     jschultz@cnds.jhu.edu - contribution to process group membership.
 *    Theo Schlossnagle theos@cnds.jhu.edu - Perl library and Skiplists.
 *
 */


#ifndef INC_STATUS
#define INC_STATUS

#include "arch.h"
#include "scatter.h"

typedef	struct	dummy_status{
	int32	sec;
	int32	state;
	int32	gstate;
	int32	packet_sent;
	int32	packet_recv;
	int32	packet_delivered;
	int32	retrans;
	int32	u_retrans;
	int32	s_retrans;
	int32	b_retrans;
	int32   aru;
	int32   my_aru;
	int32   highest_seq;
	int32	token_hurry;
	int32	token_rounds;
	int32	my_id;
	int32	leader_id;
	int32	message_delivered;
	int16	membership_changes;
	int16	num_procs;
	int16	num_segments;
	int16	window;
	int16	personal_window;
	int16	num_sessions;
	int16	num_groups;
	int16	major_version;
	int16	minor_version;
	int16	patch_version;
} status;

#undef  ext
#ifndef	status_ext
#define	ext	extern
#else
#define ext
#endif

ext 	status	GlobalStatus; 

void	Stat_init();
void	Stat_handle_message( sys_scatter *scat );

#endif	/* INC_STATUS */ 
